
#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

       #include <unistd.h>
       #include <stdlib.h>
       #include <stdio.h>

int
main(int argc, char *argv[])
{

int flags; 
int opt;

int opt_e;
int opt_E;
int opt_n;
int opt_max;

flags = 0;
opt_E = 0;
opt_e = 0;
opt_n = 0;
opt_max = 0;

opterr = 0;

while ((opt = getopt(argc, argv, "neE")) != -1){
  switch (opt) {
    case 'e':
         flags = 1;
         opt_e = optind;
         opt_max = optind;
         break;

    case 'E':
         flags = 2;
         opt_E = optind;
         opt_max = optind;
         break;

    case 'n':
         flags = 3;
         opt_n = optind;
         opt_max = optind;
         break;
   }
}

/* выполняется если опций указано не было */
if (flags == 0) {
  PrintWords(1,argc,argv);
  printf("\n");
} else {

/* выполняется если последняя опция была -e */
  if (opt_e == opt_max)
  PrintWords2(optind,argc,argv);

/* выполняется если последняя опция была -E */
  if (opt_E == opt_max)
     PrintWords(optind,argc,argv);

/* выполняется если последняя опция была -n */
  if (opt_n == opt_max){
     /* смотрю указал ли пользователь опцию -e */
     if (opt_e != 0){ 
        /* смотрю указал ли пользователь -E после того как указал опцию -е */
        if (opt_e > opt_E)  
           PrintWords2(optind, argc, argv);
        else
           PrintWords(optind, argc, argv);
     } else 
        PrintWords(optind, argc, argv);
    }

  if (opt_n == 0)
     printf("\n");
}


exit(EXIT_SUCCESS);
}

// эту функцию я создала для печати слов без учета спец команд \\n \\t и т.д.
void PrintWords(int optind1, int argc1, char *argv1[] )
{
     int i;
     for (i = optind1; i < argc1; i++) {
        if (i == (argc1 - 1)) 
           printf("%s", argv1[i]);
        else
           printf("%s ", argv1[i]); 
     }
}

// эту функцию я создала для печати слов с учетом спец команд \\n \\t и т.д.
void PrintWords2(int optind2,int argc2, char *argv2[] )
{
 int i;
 char *c;
 for (i = optind2; i < argc2; i++) {
     c = argv2[i];

     while (*c) {
           if (*c == '\\') {
              c++;
                 switch(*c) {
                 case '\\':
                       printf("\\"); /* \\     backslash */
                       break;
 
                 case 'a':
                       printf("\a"); /* \a     alert (BEL) */
                       break;

                 case 'b': 
                       printf("\b"); /* \b     backspace */
                       break;

                 case 'c':
                      /* printf("\c");  \c     produce no further output*/
                      break;

                 case 'f':
                      printf("\f");  /* \f     form feed */
                      break;

                 case 'n':
                      printf("\n"); /*   \n     new line */
                      break;

                 case 'r':
                      printf("\r"); /*   \r     carriage return */
                      break;

                 case 't':
                      printf("\t "); /*  \t     horizontal tab */
                      break;

                 case 'v':
                      printf("\v"); /*  \v     vertical tab */
                      break;
                 };
           } else {
             printf("%c",*c); 
             } 
           c++;
     } 

     if (i != argc2-1) printf(" "); 
 } 
}






